# all files / ol/ animation.js

31.82% Statements 28/88
21.74% Branches 10/46
50% Functions 4/8
31.82% Lines 28/88

    1
    2
    3
    4
    5
    6
    7
    8
    9
    10
    11
    12
    13
    14
    15
    16
    17
    18
    19
    20
    21
    22
    23
    24
    25
    26
    27
    28
    29
    30
    31
    32
    33
    34
    35
    36
    37
    38
    39
    40
    41
    42
    43
    44
    45
    46
    47
    48
    49
    50
    51
    52
    53
    54
    55
    56
    57
    58
    59
    60
    61
    62
    63
    64
    65
    66
    67
    68
    69
    70
    71
    72
    73
    74
    75
    76
    77
    78
    79
    80
    81
    82
    83
    84
    85
    86
    87
    88
    89
    90
    91
    92
    93
    94
    95
    96
    97
    98
    99
    100
    101
    102
    103
    104
    105
    106
    107
    108
    109
    110
    111
    112
    113
    114
    115
    116
    117
    118
    119
    120
    121
    122
    123
    124
    125
    126
    127
    128
    129
    130
    131
    132
    133
    134
    135
    136
    137
    138
    139
    140
    141
    142
    143
    144
    145
    146
    147
    148
    149
    150
    151
    152
    153
    154
    155
    156
    157
    158
    159
    160
    161
    162
    163
    164
    165
    166
    167
    1681×

    1×
    1×
    1×
    1×
    1×

    1×

    1×
    1×
    1×
    1×
    1×
    1×
    1×

    1×

    1×

    1×

    1×

    1×

    1×
    1×
    1×
    1×
    1×

    1×

    1×

    1×

    1×

     goog.provide('ol.animation');

    goog.require('ol');
    goog.require('ol.PreRenderFunction');
    goog.require('ol.ViewHint');
    goog.require('ol.coordinate');
    goog.require('ol.easing');

    /**
     * Generate an animated transition that will "bounce" the resolution as it
     * approaches the final value.
     * @param {olx.animation.BounceOptions} options Bounce options.
     * @return {ol.PreRenderFunction} Pre-render function.
     * @api
     */
    ol.animation.bounce = function(options) {
      var resolution = options.resolution;
      var start = options.start ? options.start : Date.now();
      var duration = options.duration !== undefined ? options.duration : 1000;
      var easing = options.easing ?
          options.easing : ol.easing.upAndDown;
      return (
          /**
           * @param {ol.Map} map Map.
           * @param {?olx.FrameState} frameState Frame state.
           */
          function(map, frameState) {
            if (frameState.time < start) {
              frameState.animate = true;
              frameState.viewHints[ol.ViewHint.ANIMATING] += 1;
              return true;
            } else if (frameState.time < start + duration) {
              var delta = easing((frameState.time - start) / duration);
              var deltaResolution = resolution - frameState.viewState.resolution;
              frameState.animate = true;
              frameState.viewState.resolution += delta * deltaResolution;
              frameState.viewHints[ol.ViewHint.ANIMATING] += 1;
              return true;
            } else {
              return false;
            }
          });
    };

    /**
     * Generate an animated transition while updating the view center.
     * @param {olx.animation.PanOptions} options Pan options.
     * @return {ol.PreRenderFunction} Pre-render function.
     * @api
     */
    ol.animation.pan = function(options) {
      var source = options.source;
      var start = options.start ? options.start : Date.now();
      var sourceX = source[0];
      var sourceY = source[1];
      var duration = options.duration !== undefined ? options.duration : 1000;
      var easing = options.easing ?
          options.easing : ol.easing.inAndOut;
      return (
          /**
           * @param {ol.Map} map Map.
           * @param {?olx.FrameState} frameState Frame state.
           */
          function(map, frameState) {
            Iif (frameState.time < start) {
              frameState.animate = true;
              frameState.viewHints[ol.ViewHint.ANIMATING] += 1;
              return true;
            } else Iif (frameState.time < start + duration) {
              var delta = 1 - easing((frameState.time - start) / duration);
              var deltaX = sourceX - frameState.viewState.center[0];
              var deltaY = sourceY - frameState.viewState.center[1];
              frameState.animate = true;
              frameState.viewState.center[0] += delta * deltaX;
              frameState.viewState.center[1] += delta * deltaY;
              frameState.viewHints[ol.ViewHint.ANIMATING] += 1;
              return true;
            } else {
              return false;
            }
          });
    };

    /**
     * Generate an animated transition while updating the view rotation.
     * @param {olx.animation.RotateOptions} options Rotate options.
     * @return {ol.PreRenderFunction} Pre-render function.
     * @api
     */
    ol.animation.rotate = function(options) {
      var sourceRotation = options.rotation ? options.rotation : 0;
      var start = options.start ? options.start : Date.now();
      var duration = options.duration !== undefined ? options.duration : 1000;
      var easing = options.easing ?
          options.easing : ol.easing.inAndOut;
      var anchor = options.anchor ?
          options.anchor : null;

      return (
          /**
           * @param {ol.Map} map Map.
           * @param {?olx.FrameState} frameState Frame state.
           */
          function(map, frameState) {
            if (frameState.time < start) {
              frameState.animate = true;
              frameState.viewHints[ol.ViewHint.ANIMATING] += 1;
              return true;
            } else if (frameState.time < start + duration) {
              var delta = 1 - easing((frameState.time - start) / duration);
              var deltaRotation =
                  (sourceRotation - frameState.viewState.rotation) * delta;
              frameState.animate = true;
              frameState.viewState.rotation += deltaRotation;
              if (anchor) {
                var center = frameState.viewState.center;
                ol.coordinate.sub(center, anchor);
                ol.coordinate.rotate(center, deltaRotation);
                ol.coordinate.add(center, anchor);
              }
              frameState.viewHints[ol.ViewHint.ANIMATING] += 1;
              return true;
            } else {
              return false;
            }
          });
    };

    /**
     * Generate an animated transition while updating the view resolution.
     * @param {olx.animation.ZoomOptions} options Zoom options.
     * @return {ol.PreRenderFunction} Pre-render function.
     * @api
     */
    ol.animation.zoom = function(options) {
      var sourceResolution = options.resolution;
      var start = options.start ? options.start : Date.now();
      var duration = options.duration !== undefined ? options.duration : 1000;
      var easing = options.easing ?
          options.easing : ol.easing.inAndOut;
      return (
          /**
           * @param {ol.Map} map Map.
           * @param {?olx.FrameState} frameState Frame state.
           */
          function(map, frameState) {
            Iif (frameState.time < start) {
              frameState.animate = true;
              frameState.viewHints[ol.ViewHint.ANIMATING] += 1;
              return true;
            } else Iif (frameState.time < start + duration) {
              var delta = 1 - easing((frameState.time - start) / duration);
              var deltaResolution =
                  sourceResolution - frameState.viewState.resolution;
              frameState.animate = true;
              frameState.viewState.resolution += delta * deltaResolution;
              frameState.viewHints[ol.ViewHint.ANIMATING] += 1;
              return true;
            } else {
              return false;
            }
          });
    };